using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using IE = Interop.SHDocVw;
using AddinExpress.IE;
using TweetSharp;
using System.Diagnostics;

namespace TweetPic
{
    /// <summary>
    /// Add-in Express for Internet Explorer Module
    /// </summary>
    [ComVisible(true), Guid("2F6FD1E0-69CF-473F-9744-50044DB651E4")]
    public class IEModule : AddinExpress.IE.ADXIEModule
    {
        public IEModule()
        {
            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        private ADXIEContextMenuCommandItem tweetPicContextMenu;

        private ADXIEToolBarItem adxieToolBarItem1;

        public IEModule(IContainer container)
        {
            container.Add(this);

            InitializeComponent();
            //Please write any initialization code in the OnConnect event handler
        }

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxieToolBarItem1 = new AddinExpress.IE.ADXIEToolBarItem(this.components);
            this.tweetPicContextMenu = new AddinExpress.IE.ADXIEContextMenuCommandItem(this.components);
            // 
            // adxieToolBarItem1
            // 
            this.adxieToolBarItem1.MenuText = "adxieToolBarItem1";
            // 
            // tweetPicContextMenu
            // 
            this.tweetPicContextMenu.Caption = "Tweet this Pic";
            this.tweetPicContextMenu.Contexts = AddinExpress.IE.ADXIEMenuContexts.mcImages;
            this.tweetPicContextMenu.Description = "Insert this image url in a new tweet.";
            this.tweetPicContextMenu.Items = null;
            this.tweetPicContextMenu.OnClick += new AddinExpress.IE.ADXIEMenuItemClick_EventHandler(this.tweetPicContextMenu_OnClick);
            // 
            // IEModule
            // 
            this.ContextMenu.Add(this.tweetPicContextMenu);
            this.HandleShortcuts = true;
            this.LoadInMainProcess = false;
            this.ModuleName = "TweetPic";
            this.ToolBars.Add(this.adxieToolBarItem1);
            this.OnConnect += new AddinExpress.IE.ADXIEConnect_EventHandler(this.IEModule_OnConnect);

        }
        #endregion

        #region ADX automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void RegisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void UnregisterIEModule(Type t)
        {
            AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t);
        }

        [ComVisible(true)]
        public class IECustomContextMenuCommands :
            AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher
        {
        }

        [ComVisible(true)]
        public class IECustomCommands :
            AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher
        {
        }

        #endregion

        public IE.WebBrowser IEApp
        {
            get
            {
                return (this.IEObj as IE.WebBrowser);
            }
        }

        public mshtml.HTMLDocument HTMLDocument
        {
            get
            {
                return (this.HTMLDocumentObj as mshtml.HTMLDocument);
            }
        }

        TwitterService twitterService = null;
        OAuthRequestToken requestToken = null;

        private void IEModule_OnConnect(object sender, int threadId)
        {
            if (!Properties.Settings.Default.HasPermission)
            {
                if (MessageBox.Show(this, "You have not given TweetPic permission to send messages via your Twitter account, would you like to do that now?"
                    , "Permission needed", MessageBoxButtons.YesNo) == DialogResult.Yes)
                {

                    TwitterClientInfo twitterClientInfo = new TwitterClientInfo();
                    twitterClientInfo.ConsumerKey = Properties.Settings.Default.ConsumerKey;
                    twitterClientInfo.ConsumerSecret = Properties.Settings.Default.ConsumerSecret;

                    twitterService = new TwitterService(twitterClientInfo);
                    requestToken = twitterService.GetRequestToken();
                    Uri authUrl = twitterService.GetAuthorizationUri(requestToken);
                    Process.Start(authUrl.AbsoluteUri);

                    using (frmPin pinForm = new frmPin())
                    {
                        if (pinForm.ShowDialog(this) == DialogResult.OK)
                        {
                            OAuthAccessToken accessToken = twitterService.GetAccessToken(requestToken, pinForm.Pin);
                            Properties.Settings.Default.AccessToken = accessToken.Token;
                            Properties.Settings.Default.AccessTokenSecret = accessToken.TokenSecret;
                        }
                    }
                }
                Properties.Settings.Default.HasPermission = true;
                Properties.Settings.Default.Save();
            }
        }

        private void tweetPicContextMenu_OnClick(object sender, object htmlElement)
        {
            mshtml.HTMLImgClass img = (mshtml.HTMLImgClass)htmlElement;

            TwitterClientInfo twitterClientInfo = new TwitterClientInfo();
            twitterClientInfo.ConsumerKey = Properties.Settings.Default.ConsumerKey;
            twitterClientInfo.ConsumerSecret = Properties.Settings.Default.ConsumerSecret;

            twitterService = new TwitterService(twitterClientInfo);
            twitterService.AuthenticateWith(Properties.Settings.Default.AccessToken, Properties.Settings.Default.AccessTokenSecret);
            TwitterStatus status = twitterService.SendTweet("Check this Out - " + img.href);
        }
    }
}

